//+------------------------------------------------------------------+
//|                                                    compile_c.mq4 |
//|                                                Maxim A.Kuznetsov |
//|                                                       nektomk.ru |
//+------------------------------------------------------------------+
#property copyright "Maxim A.Kuznetsov"
#property link      "nektomk.ru"
#property version   "1.00"
#property strict
#property description "ATcl (Tcl bindings for MT4) http://nektomk.ru/ATcl"
#property description  "------------------"
#property description "This demo demonstrate how to compile and use C/C++ on-the-fly"
#property description "------------------"
#property description "The library is provided free of charge, without restrictions"
#property description "You can sponsor the further development of ATcl - http://nektomk.ru/ATcl/donate"


#include <ATcl\\ATcl.mqh>

const string c=
"static double sum(double x, double y) {"
"    return x+y;"
"}";

ATcl *tcl;
void OnStart()
{
   ATcl_OnInit();
   tcl=new ATcl;
   if (tcl!=NULL && tcl.Ready()) {
      bool ok=false;
      do {
         // use critcl package (compiler environment)
         if (tcl.Eval("package require critcl")!=TCL_OK) break;
         // pass some c/c++ to compiler
         if (tcl.Call(tcl.Obj("critcl::ccode"),tcl.Obj(c))!=TCL_OK) break;
         // make callable proc
         if (tcl.Eval("critcl::cproc mysum { double x double y } double { return sum(x,y);}")!=TCL_OK) break;
         // use it :-)
         double ret=tcl.DoubleCall(tcl.Obj("mysum"),tcl.Obj((double)5.0),tcl.Obj((double)7.1));
         PrintFormat("5.0+7.1=%f",ret);
         ret=tcl.DoubleEval("mysum 77.0 14.88");
         PrintFormat("77.0+14.88=%f",ret);
         ok=true;
      } while(0);
      if (!ok) {
         PrintFormat("Error : %s",tcl.StringResult());
      }
   }
   delete tcl;
   ATcl_OnDeinit();
}

