//+------------------------------------------------------------------+
//|                                                         info.mq4 |
//|                                                Maxim A.Kuznetsov |
//|                                                      luxtrade.tk |
//+------------------------------------------------------------------+


#property copyright "Maxim A.Kuznetsov"
#property link      "nektomk.ru/ATcl"
#property version   "1.00"
#property strict
#property script_show_inputs

#property description "ATcl (Tcl bindings for MT4) http://nektomk.ru/ATcl"
#property description "------------------"
#property description "This demo shows information from tcl"
#property description "Your may see some methods for invocation tcl and access to variables"
#property description "------------------"
#property description "The library is provided free of charge, without restrictions"
#property description "You can sponsor the further development of ATcl - http://nektomk.ru/ATcl/donate"


#include <ATcl/ATcl.mqh>

void OnStart()
{
   ATcl_OnInit(); // initialize library
   ATcl *tcl=new ATcl;  // create new interp
   if (!tcl.Ready()) {
      Alert("unable to create interp.");
   } else {
      // simplify evaluate script and got results
      if (tcl.Eval("info tclversion")!=TCL_OK) {
         PrintFormat("error eval: %s",tcl.StringResult());
      } else {
         PrintFormat("info version : %s",tcl.StringResult());
      }
      // call command and iterate list
      if (tcl.Call(tcl.Obj("info"),tcl.Obj("vars"))!=TCL_OK) {
         PrintFormat("error call: %s",tcl.StringResult());   
      } else {
         Tcl_Obj list=tcl.Result(); // take result as object
         tcl.Ref(list);
         int limit=tcl.Count(list);
         for(int index=0;index<limit;index++) {
            PrintFormat("  %d  %s",index,tcl.String(list,index));  // take string from list by index
         }
         PrintFormat("all globals: %s",tcl.String(list)); // take string from complete list
         tcl.Unref(list);
      }
      // take value from variable
      string auto_path=tcl.String(tcl.Get("auto_path")); // get object from var and convert to string
      PrintFormat("auto_path : %s",auto_path);
      // iterate hash (array in tcl notation)
      // take all keys from hash
      Tcl_Obj names=tcl.ObjEval("array names tcl_platform");   // simplified Eval to Tcl_Obj
      if (names!=0) {
         Tcl_Obj tcl_platform=tcl.Ref(tcl.Obj("tcl_platform"));   // create and ref. object
         tcl.Ref(names);
         int limit=tcl.Count(names);
         for(int index=0;index<limit;index++) {
            Tcl_Obj key=tcl.ListIndex(names,index);
            Tcl_Obj value=tcl.Get(tcl_platform,key);
            PrintFormat("tcl_platform(%s) : %s",tcl.String(key),tcl.String(value));
         }
         tcl.Unref(names);
         tcl.Unref(tcl_platform);
      }
   }
   delete tcl; // destroy interp
   ATcl_OnDeinit(); // finalize library
}

