//+------------------------------------------------------------------+
//|                                                      oostack.mq4 |
//|                                                Maxim A.Kuznetsov |
//|                                                      luxtrade.tk |
//+------------------------------------------------------------------+
#property copyright "Maxim A.Kuznetsov"
#property link      "luxtrade.tk"
#property version   "1.00"
#property strict
#property script_show_inputs
#property description "ATcl (Tcl bindings for MT4) http://nektomk.ru/ATcl"
#property description  "------------------"
#property description "This demo show howto use Object Orientation with Tcl & MQL both"
#property description "------------------"
#property description "The library is provided free of charge, without restrictions"
#property description "You can sponsor the further development of ATcl - http://nektomk.ru/ATcl/donate"


#include <ATcl\\ATcl.mqh>
ATcl *tcl;

class Stack {
protected:
   Tcl_Obj obj;
public:
   Stack() {
      obj=tcl.ObjEval("Stack new");
      tcl.Ref(obj);
   }
   ~Stack() {
      tcl.Call(obj,tcl.Obj("destroy"));
      tcl.Unref(obj);
   }
   void Push(string s) {
      tcl.Call(obj,tcl.Obj("Push"),tcl.Obj(s));
   }
   string Pop() {
      return tcl.StringCall(obj,tcl.Obj("Pop"));
   }
};

void OnStart()
{
   ATcl_OnInit();
   tcl=new ATcl;
   if (tcl!=NULL && tcl.Ready()) {
      if (tcl.Eval("source MQL4/Libraries/ATcl/demo/Stack.tcl")!=TCL_OK) {
         PrintFormat("Error: %s",tcl.StringResult());
      } else {
         Stack stack;
         stack.Push("hello");
         stack.Push("word");
         PrintFormat("pop: %s",stack.Pop());
         PrintFormat("pop: %s",stack.Pop());
      }
   }
   delete tcl;
   ATcl_OnDeinit();
}

